#if !defined(AFX_DEPTH_RANGE__91E1E1F3_0D6C_4222_9D71_EAB2E415688C__INCLUDED_) // sony
#define AFX_DEPTH_RANGE__91E1E1F3_0D6C_4222_9D71_EAB2E415688C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#if SONY_DEPTH_RANGE

#include "H264AVCCommonLib.h"
#include "H264AVCCommonLib/HeaderSymbolReadIf.h"
#include "H264AVCCommonLib/HeaderSymbolWriteIf.h"

H264AVC_NAMESPACE_BEGIN

class AcquisitiionElement;

class H264AVCCOMMONLIB_API AcquisitionElement
{

 public:
	 AcquisitionElement() : 
      //m_ucSkipFlag( NULL )
	//, m_ucElementEqual( 0 )
	//, m_ucExponentSkipFlag ( NULL )
	//, m_iSingDiff ( NULL )
	//, m_iExponentDiff ( NULL )
	//, m_iMantissaDiff ( NULL )
	//, m_ucDeltaFlag ( 0 )
	m_ucElementEqual ( 0 )
	, m_ucPresentFlag ( 0 )
	, m_ucElementFlag ( 0 )
	, m_ucPrecMode ( 0 )
	, m_iPrecision ( 0 )
	, m_uiMantissaLength ( 0 )
	, m_iExponentSize ( 0 )
	, m_iSign ( 0 )
	, m_iExponent ( 0 )
	, m_iMantissa ( 0 )
	, m_iMantissaBits ( 0 )
	, m_iOrgValue ( 0.0 )
	, m_iRecValue ( 0.0 )
	 { }
   ~AcquisitionElement()
   {
  //   release_memory();
   }

 private:
	// UChar *m_ucSkipFlag;
	 UChar m_ucElementEqual;
	// UChar *m_ucExponentSkipFlag;
	 
	// Int32 *m_iSingDiff;
	// Int32 *m_iExponentDiff;
	// Int32 *m_iMantissaDiff;

	// UChar m_ucDeltaFlag;

	 UChar m_ucPresentFlag;

	 UChar m_ucElementFlag;
	 UChar m_ucPrecMode;

	 Int32 m_iPrecision;
	 UInt m_uiMantissaLength;
	 Int32 m_iExponentSize;

	 Int32 m_iSign;
	 Int32 m_iExponent;
	 Int32 m_iMantissa;
	 Int32 m_iMantissaBits;

	 Double m_iOrgValue;
	 Double m_iRecValue;

public:

	void setOrgValue (Int32 value)	 { m_iOrgValue = value; } 
	void setPresentFlag (UChar uc)	 { m_ucPresentFlag = uc; }
	void setMantissaLength (UInt ui) { m_uiMantissaLength = ui; }
	void setExponentSize (Int32 i)	 { m_iExponentSize = i; }

	Int32 getOrgValue ()			  { return m_iOrgValue; }
	UChar getPresentFlag ()			  { return m_ucPresentFlag;}

   Int32 getVarLength(Int32 iExponent, Int32 iPrecision);
   void CalcExponentMantissa ();
   void CalcRecValue ();

   ErrVal write ( HeaderSymbolWriteIf* pcWriteIf) const;

/*
   void initialize_memory(UInt uiNumDepthInfoMinus1)
   {
      m_ucSkipFlag					= new UChar[uiNumDepthInfoMinus1+1];
      m_ucExponentSkipFlag			= new UChar[uiNumDepthInfoMinus1+1];
      m_iSingDiff					= new Int32[uiNumDepthInfoMinus1+1];
      m_iExponentDiff				= new Int32[uiNumDepthInfoMinus1+1];
      m_iMantissaDiff				= new Int32[uiNumDepthInfoMinus1+1];
   }

   void release_memory()
   {
     delete [] m_ucSkipFlag;
     delete [] m_ucExponentSkipFlag;
     delete [] m_iSingDiff;
     delete [] m_iExponentDiff;
     delete [] m_iMantissaDiff;
   }
};
	 /*
	double_split element[MAX_CODEVIEW];
	int32 exponent_size;

	byte skip_flag[MAX_CODEVIEW];
	byte element_equal;
	byte exponent_skip_flag[MAX_CODEVIEW];

	int32 sign_diff[MAX_CODEVIEW];
	int32 exponent_diff[MAX_CODEVIEW];
	int32 mantissa_diff[MAX_CODEVIEW];

	byte delta_flag;
	byte element_flag;
	byte pred_mode;

	int32 precision;
	int32 mantissa_length;


	double original[MAX_CODEVIEW];
	double rec[MAX_CODEVIEW];
*/
};


class H264AVCCOMMONLIB_API DepthRange
{

//protected:
public:
   DepthRange();
   ~DepthRange();
 public:
   AcquisitionElement* getMaxZ(UInt uiViewIdx, UInt uiFrameIdx) const             { return &m_uiMaxZ[uiViewIdx][uiFrameIdx];}
   AcquisitionElement* getMinZ(UInt uiViewIdx, UInt uiFrameIdx) const             { return &m_uiMinZ[uiViewIdx][uiFrameIdx];}
   UChar getMaxZElementEqualFlag( UInt uiIdx ) const {return m_ucMaxZElementEqualFlag[uiIdx];}
   UChar getMinZElementEqualFlag( UInt uiIdx ) const {return m_ucMinZElementEqualFlag[uiIdx];}
   UChar getMaxZPresentFlag( UInt uiIdx ) const {return m_ucMaxZPresentFlag[uiIdx];}
   UChar getMinZPresentFlag( UInt uiIdx ) const {return m_ucMinZPresentFlag[uiIdx];}
   	

   UInt getNumFramesMinus1() const               { return m_uiNumFramesMinus1;}
   UInt getNumDepthViewsMinus1() const                       { return m_uiNumDepthViewsMinus1; }
   UInt getAllDepthRangeSameFlag () const					 { return m_uiAllDepthRangeSameFlag;}
	 
   void setOrgMaxZ(UInt uiViewIdx, UInt uiFrameIdx, Int32 value)        { m_uiMaxZ[uiViewIdx][uiFrameIdx].setOrgValue(value);}
   void setOrgMinZ(UInt uiViewIdx, UInt uiFrameIdx, Int32 value)        { m_uiMinZ[uiViewIdx][uiFrameIdx].setOrgValue(value);}

   void setMaxZElementEqualFlag( UInt uiIdx, UChar uc) { m_ucMaxZElementEqualFlag[uiIdx] = uc;}
   void setMinZElementEqualFlag( UInt uiIdx, UChar uc) { m_ucMinZElementEqualFlag[uiIdx] = uc;}
   void setMaxZPresentFlag( UInt uiIdx, UChar uc) { m_ucMaxZPresentFlag[uiIdx] = uc;}
   void setMinZPresentFlag( UInt uiIdx, UChar uc) { m_ucMinZPresentFlag[uiIdx] = uc;}

   void setNumFramesMinus1(UInt value)						 { m_uiNumFramesMinus1			 = value;}
   void setNumDepthViewsMinus1(UInt value)                   { m_uiNumDepthViewsMinus1       = value;}
   void setAllDepthRangeSameFlag(UInt value)                 { m_uiAllDepthRangeSameFlag         = value;}

   ErrVal write( HeaderSymbolWriteIf* pcWriteIf, UInt uiNumViewsMinus1, 
				 UInt uiFrameNum,  Bool b3dvExtensionSPSFlag = false) const;

 private:
   AcquisitionElement **m_uiMaxZ;
   AcquisitionElement **m_uiMinZ;

   UChar *m_ucMaxZElementEqualFlag;
   UChar *m_ucMinZElementEqualFlag;
   UChar *m_ucMaxZPresentFlag;
   UChar *m_ucMinZPresentFlag;

   UInt m_uiAllDepthRangeSameFlag;
   UInt m_uiNumDepthInfoMinus1;
   UInt m_uiNumFramesMinus1;
   UInt m_uiNumDepthViewsMinus1;
	 /*
	 
   UInt *m_uiDepthInfoId;
   UInt *m_uiDepthType;
   UInt *m_uiPrecision;
   UInt *m_uiAllFramesInViewComponentsFlag;


   UInt *m_uiRefDepthInfoId;
*/

 public:
   static ErrVal create( DepthRange*& rpcDepthRange );
   virtual ErrVal init(UInt uiAllDepthRangeSameFlag,
					   UInt uiNumDepthViewsMinus1, 
					   UInt uiNumFramesMinus1);
   virtual ErrVal uninit(UInt uiAllDepthRangeSameFlag,
						UInt uiNumDepthViewsMinus1);

/*
   void initialize_memory(UInt uiNumDepthInfoMinus1, UInt uiNumFramesMinus1);
   void release_memory();

 /*
   void initialize_memory_seq(UInt uiNumDepthInfoMinus1)
   {
      m_uiDepthInfoId = new UInt[uiNumDepthInfoMinus1+1];
      m_uiDepthType   = new UInt[uiNumDepthInfoMinus1+1];
      m_uiPrecision   = new UInt[uiNumDepthInfoMinus1+1];
      m_uiAllFramesInViewComponentsFlag = new UInt[uiNumDepthInfoMinus1+1];
      m_uiNumFramesMinus1 = new UInt[uiNumDepthInfoMinus1+1];
   }
   void initialize_memory_frames(UInt uiNumDepthInfoMinus1, UInt uiNumFramesMinus1)
   {
     m_uiMaxD = new UInt *[uiNumDepthInfoMinus1+1];
     m_uiMinD = new UInt *[uiNumDepthInfoMinus1+1];
     for( int i=0;i<uiNumDepthInfoMinus1+1;i++)
     {
       m_uiMaxD[i] = new UInt[uiNumFramesMinus1+1];
       m_uiMinD[i] = new UInt[uiNumFramesMinus1+1];
     }
   }
   void initialize_memory_ref(UInt uiNumDepthViewsMinus1)
   {
     for( int i=0;i<uiNumDepthViewsMinus1+1;i++)
     {
        m_uiRefDepthInfoId   = new UInt[uiNumDepthViewsMinus1+1];
     }
   }

   void release_memory()
   {
     delete [] m_uiDepthInfoId;
     delete [] m_uiDepthType;
     delete [] m_uiPrecision;
     delete [] m_uiAllFramesInViewComponentsFlag;
     for( int i=0;i<m_uiNumDepthInfoMinus1+1;i++ )
     {
       delete [] m_uiMaxD[i];
       delete [] m_uiMinD[i];
     }
     delete [] m_uiMaxD;
     delete [] m_uiMinD;
     delete [] m_uiNumFramesMinus1;
     delete [] m_uiRefDepthInfoId;
   }
*/
 };

H264AVC_NAMESPACE_END

#endif

#endif









